/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.23 Revision 1.58
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.23 2006/06/17 20:35:02 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.58 2008/04/22 11:04:05 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org>
7 8
8# vdr-plugin.eclass 9# vdr-plugin.eclass
9# 10#
10# eclass to create ebuilds for vdr plugins 11# eclass to create ebuilds for vdr plugins
11# 12#
37# 38#
38# If ${VDR_RCADDON_FILE} is set install this file 39# If ${VDR_RCADDON_FILE} is set install this file
39# else install ${FILESDIR}/rc-addon.sh if it exists. 40# else install ${FILESDIR}/rc-addon.sh if it exists.
40# 41#
41# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh 42# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
42# (in example vdr-femon this would be /usr/lib/vdr/rcscript/plugin-femon.sh) 43# (in example vdr-femon this would be /usr/share/vdr/rcscript/plugin-femon.sh)
43# 44#
44# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr 45# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr
45# It could be used for special startup actions for this plugins, or to create the 46# It could be used for special startup actions for this plugins, or to create the
46# plugin command line options from a nicer version of a conf.d file. 47# plugin command line options from a nicer version of a conf.d file.
47 48
49# HowTo use own local patches; Example
50#
51# Add to your /etc/make.conf:
52# VDR_LOCAL_PATCHES_DIR="/usr/local/patch"
53#
54# Add two DIR's in your local patch dir, ${PN}/${PV},
55# e.g for vdr-burn-0.1.0 should be:
56# /usr/local/patch/vdr-burn/0.1.0/
57#
58# all patches which ending on diff or patch in this DIR will automatically applied
59#
60
48inherit base multilib eutils flag-o-matic 61inherit base multilib eutils flag-o-matic
49 62
50IUSE="debug" 63IUSE=""
51 64
52# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes 65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
53VDRPLUGIN="${PN/#vdrplugin-/}" 66VDRPLUGIN="${PN/#vdrplugin-/}"
54VDRPLUGIN="${VDRPLUGIN/#vdr-/}" 67VDRPLUGIN="${VDRPLUGIN/#vdr-/}"
55VDRPLUGIN="${VDRPLUGIN/%-cvs/}" 68VDRPLUGIN="${VDRPLUGIN/%-cvs/}"
58 71
59# works in most cases 72# works in most cases
60S="${WORKDIR}/${VDRPLUGIN}-${PV}" 73S="${WORKDIR}/${VDRPLUGIN}-${PV}"
61 74
62# depend on headers for DVB-driver 75# depend on headers for DVB-driver
63RDEPEND="" 76DEPEND=">=media-tv/gentoo-vdr-scripts-0.3.8
77 || ( >=media-tv/gentoo-vdr-scripts-0.4.2 >=media-tv/vdrplugin-rebuild-0.2 )
78 >=app-admin/eselect-vdr-0.0.2
64DEPEND="media-tv/linuxtv-dvb-headers" 79 media-tv/linuxtv-dvb-headers"
65 80
66 81
67# this code is from linux-mod.eclass 82# New method of storing plugindb
68update_vdrplugindb() { 83# Called from src_install
84# file maintained by normal portage-methods
85create_plugindb_file() {
69 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/ 86 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
70 87 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
71 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then
72 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR}
73 touch ${VDRPLUGINDB_DIR}/vdrplugindb
74 fi
75 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
76 einfo "Adding plugin to vdrplugindb."
77 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb
78 fi
79}
80
81remove_vdrplugindb() {
82 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
83
84 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
85 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
86 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
87 fi
88}
89
90vdr-plugin_pkg_setup() {
91 # -fPIC is needed for shared objects on some platforms (amd64 and others)
92 append-flags -fPIC
93 use debug && append-flags -g
94
95 # Where should the plugins live in the filesystem
96 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
97 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
98
99 # transition to /usr/share/... will need new vdr-scripts version stable
100 VDR_RC_DIR="/usr/lib/vdr/rcscript"
101
102 # Pathes to includes
103 VDR_INCLUDE_DIR="/usr/include"
104 DVB_INCLUDE_DIR="/usr/include"
105
106
107 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/vdr/config.h)
108 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/vdr/config.h)
109 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
110
111 einfo "Building ${PF} against vdr-${VDRVERSION}"
112 einfo "APIVERSION: ${APIVERSION}"
113}
114
115vdr-plugin_src_unpack() {
116 [ -z "$1" ] && vdr-plugin_src_unpack unpack patchmakefile
117
118 while [ "$1" ]; do
119
120 case "$1" in
121 unpack)
122 base_src_unpack
123 ;;
124 patchmakefile)
125 if ! cd ${S}; then
126 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
127 ewarn "Perhaps you find one among these:"
128 cd "${WORKDIR}"
129 einfo "$(/bin/ls -1 ${WORKDIR})"
130 die "Could not change to plugin-source-directory!"
131 fi
132
133 ebegin "Patching Makefile"
134 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
135 cp Makefile Makefile.orig
136 sed -i.orig Makefile \
137 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
138 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
139 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
140 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
141 -e 's:^CXXFLAGS:#CXXFLAGS:' \
142 -e 's:-I$(VDRDIR)/include:-I$(VDRDIR):' \
143 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
144 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):' \
145 -e 's:$(VDRDIR)/\([a-z]*\.h\|Make.config\):$(VDRDIR)/vdr/\1:' \
146 -e 's:^APIVERSION = :APIVERSION ?= :' \
147 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
148 -e '1i\APIVERSION = '"${APIVERSION}"
149 eend $?
150 ;;
151 esac
152
153 shift
154 done
155}
156
157vdr-plugin_copy_source_tree() {
158 cp -r ${S} ${T}/source-tree
159 cd ${T}/source-tree
160 mv Makefile.orig Makefile
161 sed -i Makefile \
162 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
163 -e 's:^CXXFLAGS:#CXXFLAGS:' \
164 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
165 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
166}
167
168vdr-plugin_install_source_tree() {
169 einfo "Installing sources"
170 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}
171 insinto ${destdir}-${PV}
172 doins -r ${T}/source-tree/*
173
174 dosym ${VDRPLUGIN}-${PV} ${destdir}
175}
176
177vdr-plugin_src_compile() {
178 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
179
180 while [ "$1" ]; do
181
182 case "$1" in
183 prepare)
184 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
185 ;;
186 compile)
187 cd ${S}
188
189 emake ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed"
190 ;;
191 esac
192
193 shift
194 done
195}
196
197vdr-plugin_src_install() {
198 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
199 cd ${S}
200
201 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
202 local mname=${P}-Makefile
203 cp Makefile ${mname}.patched
204 cp Makefile.orig ${mname}.before
205
206 diff -u ${mname}.before ${mname}.patched > ${mname}.diff
207
208 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
209 doins ${mname}.diff
210
211 insinto "/usr/share/vdr/maintainer-data/makefile-before"
212 doins ${mname}.before
213
214 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
215 doins ${mname}.patched
216
217 fi
218
219 insinto "${VDR_PLUGIN_DIR}" 88 insinto "${NEW_VDRPLUGINDB_DIR}"
220 doins libvdr-*.so.*
221 local docfile
222 for docfile in README* HISTORY CHANGELOG; do
223 [[ -f ${docfile} ]] && dodoc ${docfile}
224 done
225 89
226 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it 90# BUG: portage-2.1.4_rc9 will delete the EBUILD= line, so we cannot use this code.
227 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd 91# cat <<-EOT > "${D}/${DB_FILE}"
92# VDRPLUGIN_DB=1
93# CREATOR=ECLASS
94# EBUILD=${CATEGORY}/${PN}
95# EBUILD_V=${PVR}
96# EOT
97 {
98 echo "VDRPLUGIN_DB=1"
99 echo "CREATOR=ECLASS"
100 echo "EBUILD=${CATEGORY}/${PN}"
101 echo "EBUILD_V=${PVR}"
102 } > "${D}/${DB_FILE}"
103}
228 104
229 if [[ -n ${VDR_CONFD_FILE} ]]; then 105# Delete files created outside of vdr-plugin.eclass
230 insinto /etc/conf.d 106# vdrplugin-rebuild.ebuild converted plugindb and files are
231 newins "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN} 107# not deleted by portage itself - should only be needed as
232 fi 108# long as not every system has switched over to
109# vdrplugin-rebuild-0.2 / gentoo-vdr-scripts-0.4.2
110delete_orphan_plugindb_file() {
111 #elog Testing for orphaned plugindb file
112 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
113 local DB_FILE="${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
233 114
115 # file exists
116 [[ -f ${DB_FILE} ]] || return
234 117
235 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it 118 # will portage handle the file itself
236 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh 119 if grep -q CREATOR=ECLASS "${DB_FILE}"; then
237 120 #elog file owned by eclass - don't touch it
238 if [[ -n ${VDR_RCADDON_FILE} ]]; then 121 return
239 insinto "${VDR_RC_DIR}"
240 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
241 fi 122 fi
242 123
124 elog "Removing orphaned plugindb-file."
125 elog "\t#rm ${DB_FILE}"
126 rm "${DB_FILE}"
127}
243 128
244 129
130create_header_checksum_file()
131{
132 # Danger: Not using $ROOT here, as compile will also not use it !!!
133 # If vdr in $ROOT and / differ, plugins will not run anyway
134
245 insinto ${VDR_CHECKSUM_DIR} 135 insinto "${VDR_CHECKSUM_DIR}"
246 if [[ -f ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then 136 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
247 newins ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN} 137 newins "${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}"
248 else 138 else
249 if which md5sum >/dev/null 2>&1; then 139 if type -p md5sum >/dev/null 2>&1; then
250 cd ${S} 140 cd "${S}"
251 ( 141 (
252 cd ${ROOT}${VDR_INCLUDE_DIR}/vdr 142 cd "${VDR_INCLUDE_DIR}"
253 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2 143 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
254 ) > header-md5-${PN} 144 ) > header-md5-${PN}
255 doins header-md5-${PN} 145 doins header-md5-${PN}
256 fi 146 fi
257 fi 147 fi
258}
259
260vdr-plugin_pkg_postinst() {
261 update_vdrplugindb
262 einfo
263 einfo "The vdr plugin ${VDRPLUGIN} has now been installed."
264 einfo "To activate execute the following command:"
265 einfo
266 einfo " emerge --config ${PN}"
267 einfo
268 if [[ -n "${VDR_CONFD_FILE}" ]]; then
269 einfo "And have a look at the config-file"
270 einfo "/etc/conf.d/vdr.${VDRPLUGIN}"
271 einfo
272 fi
273}
274
275vdr-plugin_pkg_postrm() {
276 remove_vdrplugindb
277}
278
279vdr-plugin_pkg_config_final() {
280 diff ${conf_orig} ${conf}
281 rm ${conf_orig}
282}
283
284vdr-plugin_pkg_config() {
285 if [[ -z "${INSTALLPLUGIN}" ]]; then
286 INSTALLPLUGIN="${VDRPLUGIN}"
287 fi
288 # First test if plugin is already inside PLUGINS
289 local conf=/etc/conf.d/vdr
290 conf_orig=${conf}.before_emerge_config
291 cp ${conf} ${conf_orig}
292
293 einfo "Reading ${conf}"
294 if ! grep -q "^PLUGINS=" ${conf}; then
295 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1)
296 if [[ -n "${LINE}" ]]; then
297 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
298 else
299 echo 'PLUGINS=""' >> ${conf}
300 fi
301 unset LINE
302 fi
303
304 unset PLUGINS
305 PLUGINS=$(source /etc/conf.d/vdr; echo ${PLUGINS})
306
307 active=0
308 for p in ${PLUGINS}; do
309 if [[ "${p}" == "${INSTALLPLUGIN}" ]]; then
310 active=1
311 break;
312 fi
313 done
314
315 if [[ "${active}" == "1" ]]; then
316 einfo "${INSTALLPLUGIN} already activated"
317 echo
318 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
319 if [[ "${answer}" != "yes" ]]; then
320 einfo "aborted"
321 return
322 fi
323 einfo "Removing ${INSTALLPLUGIN} from active plugins."
324 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
325 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
326 -e ${LINE}'s/ \( \)*/ /g' \
327 -e ${LINE}'s/ "/"/g' \
328 -e ${LINE}'s/" /"/g'
329
330 vdr-plugin_pkg_config_final
331 return
332 fi
333
334
335 einfo "Adding ${INSTALLPLUGIN} to active plugins."
336 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
337 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
338 -e ${LINE}'s/ \( \)*/ /g' \
339 -e ${LINE}'s/ "/"/g' \
340 -e ${LINE}'s/" /"/g'
341
342 vdr-plugin_pkg_config_final
343} 148}
344 149
345fix_vdr_libsi_include() 150fix_vdr_libsi_include()
346{ 151{
347 einfo "Fixing include of libsi-headers" 152 einfo "Fixing include of libsi-headers"
351 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \ 156 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
352 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:' 157 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
353 done 158 done
354} 159}
355 160
161vdr_patchmakefile() {
162 einfo "Patching Makefile"
163 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
164 cp Makefile "${WORKDIR}"/Makefile.before
165
166 ebegin " Setting Pathes"
167 sed -i Makefile \
168 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
169 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
170 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
171 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
172 -e "/^DVBDIR/d" \
173 -e 's:-I$(DVBDIR)/include::'
174 eend $?
175
176 # maybe needed for multiproto:
177 #sed -i Makefile \
178 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
179 # -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
180 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
181
182 if ! grep -q APIVERSION Makefile; then
183 ebegin " Converting to APIVERSION"
184 sed -i Makefile \
185 -e 's:^APIVERSION = :APIVERSION ?= :' \
186 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
187 -e '/VDRVERSION =/a\APIVERSION = $(shell sed -ne '"'"'/define APIVERSION/s/^.*"\\(.*\\)".*$$/\\1/p'"'"' $(VDRDIR)/config.h)'
188 eend $?
189 fi
190
191 # Correcting Compile-Flags
192 # Do not overwrite CXXFLAGS, add LDFLAGS if missing
193 sed -i Makefile \
194 -e '/^CXXFLAGS[[:space:]]*=/s/=/?=/' \
195 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
196
197 # Disabling file stripping, useful for debugging
198 sed -i Makefile \
199 -e '/@.*strip/d' \
200 -e '/strip \$(LIBDIR)\/\$@/d' \
201 -e '/@.*\$(STRIP)/d'
202
203 # Use a file instead of a variable as single-stepping via ebuild
204 # destroys environment.
205 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
206}
207
208vdr_add_local_patch() {
209 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
210 echo
211 einfo "Applying local patches"
212 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
213 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
214 done
215 fi
216}
217
218vdr_has_gettext() {
219 has_version ">=media-video/vdr-1.5.7"
220}
221
222plugin_has_gettext() {
223 [[ -d po ]]
224}
225
226vdr_i18n_convert_to_gettext() {
227 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
228
229 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
230 ewarn "Conversion to gettext disabled in ebuild"
231 return 1
232 fi
233
234 if [[ ! -x ${i18n_tool} ]]; then
235 eerror "Missing ${i18n_tool}"
236 eerror "Please re-emerge vdr"
237 die "Missing ${i18n_tool}"
238 fi
239
240 ebegin "Auto converting translations to gettext"
241 # call i18n-to-gettext tool
242 # take all texts missing tr call into special file
243 "${i18n_tool}" 2>/dev/null \
244 |sed -e '/^"/!d' \
245 -e '/^""$/d' \
246 -e 's/\(.*\)/trNOOP(\1)/' \
247 > dummy-translations-trNOOP.c
248
249 # if there were untranslated texts just run it again
250 # now the missing calls are listed in
251 # dummy-translations-trNOOP.c
252 if [[ -s dummy-translations-trNOOP.c ]]; then
253 "${i18n_tool}" &>/dev/null
254 fi
255
256 # now use the modified Makefile
257 if [[ -f Makefile.new ]]; then
258 mv Makefile.new Makefile
259 eend 0 ""
260 else
261 eend 1 "Conversion to gettext failed. Plugin needs fixing."
262 return 1
263 fi
264}
265
266vdr_i18n_disable_gettext() {
267 ebegin "Disabling gettext support in plugin"
268 # Remove i18n Target if using older vdr
269 sed -i Makefile \
270 -e '/^all:/s/ i18n//'
271 eend 0
272}
273
274vdr_i18n() {
275 if vdr_has_gettext; then
276 einfo "VDR has gettext support"
277 if plugin_has_gettext; then
278 einfo "Plugin has gettext support, fine"
279 else
280 vdr_i18n_convert_to_gettext
281 if [[ $? != 0 ]]; then
282 eerror ""
283 eerror "Plugin will have only english OSD texts"
284 eerror "it needs manual fixing."
285 fi
286 fi
287 else
288 einfo "VDR has no gettext support"
289 if plugin_has_gettext; then
290 vdr_i18n_disable_gettext
291 fi
292 fi
293}
294
295vdr-plugin_copy_source_tree() {
296 pushd . >/dev/null
297 cp -r "${S}" "${T}"/source-tree
298 cd "${T}"/source-tree
299 cp "${WORKDIR}"/Makefile.before Makefile
300 sed -i Makefile \
301 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
302 -e 's:^CXXFLAGS:#CXXFLAGS:' \
303 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
304 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
305 popd >/dev/null
306}
307
308vdr-plugin_install_source_tree() {
309 einfo "Installing sources"
310 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
311 insinto "${destdir}-${PV}"
312 doins -r "${T}"/source-tree/*
313
314 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
315}
316
317vdr-plugin_print_enable_command() {
318 elog
319 elog "To activate this vdr-plugin execute the following command:"
320 elog "\teselect vdr-plugin enable ${PN#vdr-}"
321 elog
322}
323
324
325## exported functions
326
327vdr-plugin_pkg_setup() {
328 # -fPIC is needed for shared objects on some platforms (amd64 and others)
329 append-flags -fPIC
330
331 # Where should the plugins live in the filesystem
332 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
333 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
334
335 # was /usr/lib/... some time ago
336 # since gentoo-vdr-scripts-0.3.6 it works with /usr/share/...
337 VDR_RC_DIR="/usr/share/vdr/rcscript"
338
339 # Pathes to includes
340 VDR_INCLUDE_DIR="/usr/include/vdr"
341 DVB_INCLUDE_DIR="/usr/include"
342
343
344 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
345 LOCDIR="/usr/share/vdr/locale"
346
347 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
348 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
349 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
350
351 einfo "Compiling against"
352 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
353}
354
355vdr-plugin_src_unpack() {
356 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
357 eerror "Wrong use of vdr-plugin.eclass."
358 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
359 echo
360 eerror "Please report this at bugs.gentoo.org."
361 die "vdr-plugin_pkg_setup not called!"
362 fi
363 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile i18n
364
365 while [ "$1" ]; do
366
367 case "$1" in
368 all_but_unpack)
369 vdr-plugin_src_unpack add_local_patch patchmakefile i18n
370 ;;
371 unpack)
372 base_src_unpack
373 ;;
374 add_local_patch)
375 cd "${S}" || die "Could not change to plugin-source-directory!"
376 vdr_add_local_patch
377 ;;
378 patchmakefile)
379 cd "${S}" || die "Could not change to plugin-source-directory!"
380 vdr_patchmakefile
381 ;;
382 i18n)
383 cd "${S}" || die "Could not change to plugin-source-directory!"
384 vdr_i18n
385 ;;
386 esac
387
388 shift
389 done
390}
391
392vdr-plugin_src_compile() {
393 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
394
395 while [ "$1" ]; do
396
397 case "$1" in
398 prepare)
399 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
400 ;;
401 compile)
402 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
403 eerror "Wrong use of vdr-plugin.eclass."
404 eerror "An ebuild for a vdr-plugin will not work without"
405 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
406 echo
407 eerror "Please report this at bugs.gentoo.org."
408 die "vdr-plugin_src_unpack not called!"
409 fi
410 cd "${S}"
411
412 emake ${BUILD_PARAMS} \
413 ${VDRPLUGIN_MAKE_TARGET:-all} \
414 LOCALEDIR="${TMP_LOCALE_DIR}" \
415 || die "emake failed"
416 ;;
417 esac
418
419 shift
420 done
421}
422
423vdr-plugin_src_install() {
424 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
425 cd "${WORKDIR}"
426
427 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
428 local mname="${P}-Makefile"
429 cp "${S}"/Makefile "${mname}.patched"
430 cp Makefile.before "${mname}.before"
431
432 diff -u "${mname}.before" "${mname}.patched" > "${mname}.diff"
433
434 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
435 doins "${mname}.diff"
436
437 insinto "/usr/share/vdr/maintainer-data/makefile-before"
438 doins "${mname}.before"
439
440 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
441 doins "${mname}.patched"
442
443 fi
444
445 cd "${S}"
446 insinto "${VDR_PLUGIN_DIR}"
447 doins libvdr-*.so.*
448
449 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then
450 einfo "Installing locales"
451 cd "${TMP_LOCALE_DIR}"
452 insinto "${LOCDIR}"
453 doins -r *
454 fi
455
456 cd "${S}"
457 local docfile
458 for docfile in README* HISTORY CHANGELOG; do
459 [[ -f ${docfile} ]] && dodoc ${docfile}
460 done
461
462 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it
463 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd
464
465 if [[ -n ${VDR_CONFD_FILE} ]]; then
466 newconfd "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN}
467 fi
468
469
470 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it
471 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh
472
473 if [[ -n ${VDR_RCADDON_FILE} ]]; then
474 insinto "${VDR_RC_DIR}"
475 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
476 fi
477
478 create_header_checksum_file
479 create_plugindb_file
480}
481
482vdr-plugin_pkg_postinst() {
483 vdr-plugin_print_enable_command
484
485 if [[ -n "${VDR_CONFD_FILE}" ]]; then
486 elog "Please have a look at the config-file"
487 elog "\t/etc/conf.d/vdr.${VDRPLUGIN}"
488 elog
489 fi
490}
491
492vdr-plugin_pkg_postrm() {
493 delete_orphan_plugindb_file
494}
495
496vdr-plugin_pkg_config() {
497 ewarn "emerge --config ${PN} is no longer supported"
498 vdr-plugin_print_enable_command
499}
500
356EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 501EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config

Legend:
Removed from v.1.23  
changed lines
  Added in v.1.58

  ViewVC Help
Powered by ViewVC 1.1.20